#! /usr/bin/perl -w

# DELPHI Simple Perl Chatbot Human Friendly Interface
# Author: Scott Cornaby
# www.scottcornaby.com
#
# A simple command line interface to let humans talk to the DELPHI chatbot. 
# Built as part of a series blog posts on the topic of chatbots and general software design
#
# This code can be freely used and modified for any purpose private, educational or commercial 
# with or without attribution. Seriously, do whatever you want with.

use strict;
use warnings;

require 'DELPHI.pm';

print "DELPHI: HELLO! MY NAME IS DELPHI.\n";
print "DELPHI: I CAN USE MY MYSTERIOUS POWER TO ANSWER YES OR NO QUESTIONS LIKE:\n";
print "DELPHI: \“WILL IT RAIN TOMORROW?\” OR \“DID I PASS MY LAST TEST?\”\n";
print "DELPHI: WHAT WOULD YOU LIKE TO KNOW?\n";
print '>';

while(my $userInput = <STDIN>){
	chomp($userInput); #Remove trailing newline character with chomp
	
	if(lc($userInput) eq 'goodbye' || lc($userInput) eq 'quit'){
		last; #Break out of while loop
	}
	
	my $response = DELPHI::generateResponse($userInput,1);
	print "DELPHI: ", $response, "\n";
	print '>';
}

print "DELPHI: Come back anytime\n";
