#! /usr/bin/perl -w

# DELPHI Simple Perl Chatbot Unit Tests
# Author: Scott Cornaby
# www.scottcornaby.com
#
# A simple set of automated tests for the DELPHI chatbot
# Written to help demonstrate the basic principles of test driven development
#
# This code can be freely used and modified for any purpose private, educational or commercial 
# with or without attribution. Seriously, do whatever you want with.

use strict;
use warnings;

require 'DELPHI.pm';

my @testCases;

$testCases[0][0] = "Will this test pass?";
$testCases[0][1] = "I PREDICT THAT THIS TEST WILL PASS";

$testCases[1][0] = "Is the sky blue?";
$testCases[1][1] = "FATE INDICATES THAT THE SKY IS BLUE";

$testCases[2][0] = "Does this program work?";
$testCases[2][1] = "FATE INDICATES THAT THIS PROGRAM DOES WORK";

$testCases[3][0] = "Do computers compute?";
$testCases[3][1] = "FATE INDICATES THAT COMPUTERS COMPUTE";

$testCases[4][0] = "Do my readers enjoy this blog?";
$testCases[4][1] = "FATE INDICATES THAT YOUR READERS ENJOY THIS BLOG";

$testCases[5][0] = "Is it better to be loved or feared?";
$testCases[5][1] = "FATE INDICATES THE FORMER";

$testCases[6][0] = "Why is natural language processing so hard?";
$testCases[6][1] = "BECAUSE OF REASONS";

$testCases[7][0] = "Pumpkin mice word salad?";
$testCases[7][1] = "I'M SORRY, COULD YOU TRY REWORDING THAT AS A YES OR NO QUESTION?";

$testCases[8][0] = "Pumpkin mice word salad";
$testCases[8][1] = "I DON'T WANT TO TALK ABOUT THAT. PLEASE FEEL FREE TO ASK ME WHY";

$testCases[9][0] = "Why do you say things like that";
$testCases[9][1] = "DID YOU FORGET A QUESTION MARK? GRAMMAR IS IMPORTANT!";

$testCases[10][0] = "Is Perl a good choice for this program?";
$testCases[10][1] = "FATE INDICATES THAT PERL IS A GOOD CHOICE FOR THIS PROGRAM";

$testCases[11][0] = "Will his code compile?";
$testCases[11][1] = "I PREDICT THAT HIS CODE WILL COMPILE";

$testCases[12][0] = "Is this big blue box actually a time machine?";
$testCases[12][1] = "FATE INDICATES THAT THIS BIG BLUE BOX IS ACTUALLY A TIME MACHINE";

$testCases[13][0] = "Does this approach work better?";
$testCases[13][1] = "FATE INDICATES THAT THIS APPROACH DOES WORK BETTER";

$testCases[14][0] = "Are plurals working now?";
$testCases[14][1] = "FATE INDICATES THAT PLURALS ARE WORKING NOW";

$testCases[15][0] = "Was this tense a problem?";
$testCases[15][1] = "FATE INDICATES THAT THIS TENSE WAS A PROBLEM";

$testCases[16][0] = "Were the lights left on?";
$testCases[16][1] = "FATE INDICATES THAT THE LIGHTS WERE LEFT ON";

$testCases[17][0] = "Did this test pass?";
$testCases[17][1] = "FATE INDICATES THAT THIS TEST DID PASS";

$testCases[18][0] = "What kind of questions can you answer?";
$testCases[18][1] = "YES OR NO QUESTIONS LIKE \"WILL I HAVE GOOD LUCK TOMORROW?\" ARE THE EASIEST FOR ME TO ANSWER";

$testCases[19][0] = "Can you tell time?";
$testCases[19][1] = "THE ONLY THING I CAN REALLY DO IS ANSWER SIMPLE QUESTIONS LIKE \"WILL IT BE SUNNY TOMORROW?\"";

$testCases[20][0] = "help";
$testCases[20][1] = "JUST TYPE A QUESTION AND HIT ENTER AND I'LL DO MY BEST TO ANSWER IT. YES OR NO QUESTIONS LIKE \"DID I DO WELL ON MY TEST?\" ARE BEST";

$testCases[21][0] = "Can this code pass all the tests?";
$testCases[21][1] = "FATE INDICATES THAT THIS CODE CAN PASS ALL THE TESTS";

$testCases[22][0] = "Is that pizza yours?";
$testCases[22][1] = "FATE INDICATES THAT THAT PIZZA IS MINE";

$testCases[23][0] = "Is that dog your pet?";
$testCases[23][1] = "FATE INDICATES THAT THAT DOG IS MY PET";

$testCases[24][0] = "Is that pizza mine?";
$testCases[24][1] = "FATE INDICATES THAT THAT PIZZA IS YOURS";

$testCases[25][0] = "Is that dog my pet?";
$testCases[25][1] = "FATE INDICATES THAT THAT DOG IS YOUR PET";

my $testCount=0;
my $successCount=0;

foreach my $test (@testCases){
	my $output = DELPHI::generateResponse($test->[0]);
	if( $output ne $test->[1] ){
		print "Test Case $testCount Failed!!!\n";
		print "Input: ".$test->[0]."\n";
		print "Output: $output\n";
		print "Expected: ".$test->[1]."\n";
	}
	else{
		print "Test Case $testCount Passed\n";
		$successCount++;
	}
	
	$testCount++;
}

print "--------------------";
print "\n";
print "Passed $successCount out of $testCount tests\n";
if($testCount == $successCount){
	print "All Tests Passed!\n";
}
else{
	print "Test Failure!!!\n";
}
